package uoc.com.mimenudehoy.controller;

import org.springframework.security.authentication.AnonymousAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class LoginController 
{


	@RequestMapping(value = "/login")
	public ModelAndView login(@RequestParam(value = "error", required = false) String error, @RequestParam(value = "logout", required = false) String logout, @RequestHeader(value = "referer", required = false) final String referer) {

		ModelAndView model = new ModelAndView();
		String msgCode= "";
		if (error != null) {
			msgCode = "login.error.fail";
		}

		if (logout != null) {
			msgCode = "logout.ok";
		}

		// Spring security limitation :(
		System.out.println("URL Referer:" + referer);
		if(referer!=null && referer.contains("/admin_login")){
			return new ModelAndView("redirect:/admin_login?error="+msgCode);
		} else {
			model.getModel().put("msg", msgCode);
			model.setViewName("login");  
		}


		return model;

	}

	//TODO: corregir el logout redirige aqu
	//for 403 access denied page
	@RequestMapping(value = "/403", method = RequestMethod.GET)
	public ModelAndView accesssDenied() {

		ModelAndView model = new ModelAndView();

		//check if user is login
		Authentication auth = SecurityContextHolder.getContext().getAuthentication();
		if (!(auth instanceof AnonymousAuthenticationToken)) {
			UserDetails userDetail = (UserDetails) auth.getPrincipal();	
			model.addObject("username", userDetail.getUsername());
		}

		model.setViewName("403");
		return model;

	}



}