package uoc.com.mimenudehoy.controller.admin;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.logout.SecurityContextLogoutHandler;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class AdminLoginController 
{


	@RequestMapping(value = "/admin_login")
	public ModelAndView login(@RequestParam(value = "error", required = false) String error, @RequestParam(value = "logout", required = false) String logout, HttpServletRequest request, HttpServletResponse response) {

		ModelAndView model = new ModelAndView();
		String msgCode = "";
		if (error != null) {
			if(error.isEmpty()) msgCode = "login.error.fail";
			else msgCode = error;
		}

		if (logout != null) {
			msgCode = "logout.ok";

			Authentication auth = SecurityContextHolder.getContext().getAuthentication();
			if (auth != null){    
				new SecurityContextLogoutHandler().logout(request, response, auth);
			}
			//return "redirect:/login?logout";//You can redirect wherever you want, but generally it's a good practice to show login screen again.
		}


		model.getModel().put("msg", msgCode);
		model.setViewName("adminLogin");

		return model;

	}



}