package uoc.com.mimenudehoy.dao.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Repository;

import uoc.com.mimenudehoy.dao.DishDao;
import uoc.com.mimenudehoy.model.Dish;
import uoc.com.mimenudehoy.model.EnumCourseType;

@Repository
public class DishDaoImpl  extends GenericDaoImpl<Dish> implements DishDao {

	public Dish findByName(String name) {

		List<Dish> users = new ArrayList<Dish>();

		users = getSession().createQuery("from Dish where name like '%?%' ")
			.setParameter(0, name)
			.list();

		if (users.size() > 0) {
			return users.get(0);
		} else {
			return null;
		}
	}


	public List<Dish> findByType(EnumCourseType tipo) {

		List<Dish> list = new ArrayList<Dish>();

		list = getSession().createQuery("from Dish where course = ? ")
			.setParameter(0, tipo)
			.list();

		return list;
	}

}
