package uoc.com.mimenudehoy.dao.impl;

import java.lang.reflect.ParameterizedType;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import uoc.com.mimenudehoy.dao.GenericDao;

@Repository
public abstract class GenericDaoImpl<T> implements GenericDao<T> {

	@Autowired
	protected SessionFactory sessionFactory;

	protected Session getSession() {
		Session sess = getSessionFactory().getCurrentSession();
		if (sess == null) {
			sess = getSessionFactory().openSession();
		}
		return sess;
	}

	protected SessionFactory getSessionFactory() {
		return sessionFactory;
	}
	
	public void delete(String id) {
		Class<T> n = (Class<T>) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0];

		T entity= (T) getSession().get( n.getCanonicalName() , new Long(id));
		if (null != entity) {
			getSession().delete(entity);
		}
	}

	public T findById(String id) {
		Class<T> n = (Class<T>) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0];
		return (T) getSession().get( n , new Long(id));
	}

	public List<T> list() {
		Class<T> n = (Class<T>) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0];
		return getSession().createCriteria( n )
				.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY)
				.list();
	}

	public void save(T entity) {
		getSession().merge(entity);
	}
	
}
