package uoc.com.mimenudehoy.dao.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import uoc.com.mimenudehoy.dao.MenuDailyDao;
import uoc.com.mimenudehoy.model.MenuDaily;
import uoc.com.mimenudehoy.model.Subscription;

@Repository
public class MenuDailyDaoImpl extends GenericDaoImpl<MenuDaily> implements MenuDailyDao {

	public List<MenuDaily> findByPeriod(Date start, Date end , Subscription subs) {
		List<MenuDaily> elems = new ArrayList<MenuDaily>();

		java.sql.Date inicio = new java.sql.Date(start.getTime()); 
		java.sql.Date fin = new java.sql.Date(end.getTime());
		
		Session ses = getSession();
		elems = ses.createCriteria(MenuDaily.class)
		.add(Restrictions.ge("date", inicio))
		.add(Restrictions.le("date", fin))
		.add(Restrictions.eq("subscription", subs))
		.list();

		return elems;
	}
	
}
