package uoc.com.mimenudehoy.dao.impl;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import uoc.com.mimenudehoy.dao.DishDao;
import uoc.com.mimenudehoy.dao.RecipeDao;
import uoc.com.mimenudehoy.model.Dish;
import uoc.com.mimenudehoy.model.EnumCuisineType;
import uoc.com.mimenudehoy.model.Recipe;

@Repository
public class RecipeDaoImpl extends GenericDaoImpl<Recipe> implements RecipeDao {

	public List<Recipe> findBy(String text, EnumCuisineType tc) {

		
		List<Recipe> list = new ArrayList<Recipe>();

		String query = "FROM Recipe WHERE 1=1 ";
		if(text!=null && !text.isEmpty()) {
			query+="AND ( preparation like :preparation OR name like :preparation )";
		}
		
		if(tc!=null) {
			query+="AND cuisine = :cuisine";
		}
		
		query+=" ORDER BY date desc";
		
		System.out.println("query="+query);
		
		Query q  = getSession().createQuery( query );
		
		if(text!=null && !text.isEmpty()) {
			q.setParameter("preparation", "%"+  text + "%");
		}
		
		if(tc!=null) {
			q.setParameter("cuisine", tc);
		}
		
		
		list = q.list();

		return list;

	}

	
	public List<Recipe> getMostRecent(int numberToshow) {

		List<Recipe> list = new ArrayList<Recipe>();
		String query = "from Recipe order by date desc";
		Query q  = getSession().createQuery( query ).setMaxResults(numberToshow);
		list = q.list();

		return list;

	}


	public List<Recipe> getHighLights(boolean central, boolean footer, boolean lateral) {
		List<Recipe> list = new ArrayList<Recipe>();
		if(!(central  || footer || lateral ) ) return list;
		
		String query = "from Recipe WHERE 1=1 ";
		if (central){
			query+=" AND highlightCentral=true ";
		}
		if (footer){
			query+=" AND highlightFooter=true ";
		}
		if (lateral){
			query+=" AND highlightLateral=true ";
		}
		
		query+="order by date desc";
		Query q  = getSession().createQuery( query );
		list = q.list();

		return list;
	}
	
}
