package uoc.com.mimenudehoy.dao.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import uoc.com.mimenudehoy.dao.DishDao;
import uoc.com.mimenudehoy.dao.SubscriptionDao;
import uoc.com.mimenudehoy.model.Dish;
import uoc.com.mimenudehoy.model.Subscription;
import uoc.com.mimenudehoy.model.User;

@Repository
public class SubscriptionDaoImpl extends GenericDaoImpl<Subscription> implements SubscriptionDao {

	public List<Subscription> findActiveByUser(User user) {

		List<Subscription> list = new ArrayList<Subscription>();

		list = getSession().createQuery("from Subscription where user = :user AND :hoy between start_date AND end_date")
			.setParameter("user", user)
			.setParameter("hoy", new Date())
			.list();

		return list;
	}

	public List<Subscription> findActives() {

		List<Subscription> list = new ArrayList<Subscription>();

		list = getSession().createQuery("FROM Subscription WHERE :hoy BETWEEN start_date AND end_date")
			.setParameter("hoy", new Date())
			.list();

		return list;
	}
	

	public List<Subscription> findAllByUser(User user) {
		List<Subscription> list = new ArrayList<Subscription>();

		list = getSession().createQuery("from Subscription where user = :user ")
			.setParameter("user", user)
			.list();

		return list;
	}

	public List<Subscription> findMissingMenus() {

		List list = new ArrayList();

		list = getSession().createQuery("FROM Subscription WHERE end_date > :hoy ")
			.setParameter("hoy", new Date())
			.list();

		return list;
	}
}
