package uoc.com.mimenudehoy.dao.impl;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import uoc.com.mimenudehoy.dao.UserDao;
import uoc.com.mimenudehoy.model.User;

@Repository
public class UserDaoImpl implements UserDao {

	@Autowired
	private SessionFactory sessionFactory;

	public User findByUserName(String username) {

		List<User> users = new ArrayList<User>();

		users = getSession().createQuery("from User where username=?")
			.setParameter(0, username)
			.list();

		if (users.size() > 0) {
			return users.get(0);
		} else {
			return null;
		}

	}

	
	public void deleteUser(String username) {

		User user=findByUserName(username);
//		user.setRoles(null);
//		getSession().persist(user);
		
		if (null != user) {
			getSession().delete(user);
		}

	}

	public void deleteUser(Long id) {
		User user= (User) getSession().get(User.class,id);
		if (null != user) {
			getSession().delete(user);
		}
	}



	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}


	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}
	
	public List<User> listUsers() {
		return getSession().createCriteria(User.class)
				.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY)
				.list();
	}

	private Session getSession() {
		Session sess = getSessionFactory().getCurrentSession();
		if (sess == null) {
			sess = getSessionFactory().openSession();
		}
		return sess;
	}

	public void saveUser(User user) {
		getSession().saveOrUpdate(user);
	}

	
	
	public User getUser(Long id) {
		return (User) getSession().get(User.class, id);
	}

	
	
}
