package uoc.com.mimenudehoy.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import org.springframework.format.annotation.NumberFormat;
import org.springframework.format.annotation.NumberFormat.Style;

@Entity
@Table(name = "ingredients")
public class Ingredient implements Serializable {

	private static final long serialVersionUID = -5857566518790392004L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	
	@Column(nullable=false)
	private String name;
	
	@Column(nullable=true)
	private String description;
	
	@Enumerated(EnumType.ORDINAL)
	private EnumIntoleranceType intolerance;
	
	@Enumerated(EnumType.ORDINAL)
	private EnumOriginType origin;
	
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double energy;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double hydrates;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double fats;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double protein;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double water;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double cholesterol;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double calcium;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double potassium;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double iron;
	@NumberFormat(style=Style.NUMBER, pattern="###.##")
	private Double fiber;

	private Integer calories;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Integer getCalories() {
		return calories;
	}

	public void setCalories(Integer calories) {
		this.calories = calories;
	}

	@Column(nullable = false)
	public String getName() {
		return name;
	}



	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public EnumIntoleranceType getIntolerance() {
		return intolerance;
	}

	public void setIntolerance(EnumIntoleranceType intolerance) {
		this.intolerance = intolerance;
	}

	public EnumOriginType getOrigin() {
		return origin;
	}

	public void setOrigin(EnumOriginType origin) {
		this.origin = origin;
	}

	public Double getEnergy() {
		return energy;
	}

	public void setEnergy(Double energy) {
		this.energy = energy;
	}

	public Double getHydrates() {
		return hydrates;
	}

	public void setHydrates(Double hydrates) {
		this.hydrates = hydrates;
	}

	public Double getFats() {
		return fats;
	}

	public void setFats(Double fats) {
		this.fats = fats;
	}

	public Double getProtein() {
		return protein;
	}

	public void setProtein(Double protein) {
		this.protein = protein;
	}

	public Double getWater() {
		return water;
	}

	public void setWater(Double water) {
		this.water = water;
	}

	public Double getCholesterol() {
		return cholesterol;
	}

	public void setCholesterol(Double cholesterol) {
		this.cholesterol = cholesterol;
	}

	public Double getCalcium() {
		return calcium;
	}

	public void setCalcium(Double calcium) {
		this.calcium = calcium;
	}

	public Double getPotassium() {
		return potassium;
	}

	public void setPotassium(Double potassium) {
		this.potassium = potassium;
	}

	public Double getIron() {
		return iron;
	}

	public void setIron(Double iron) {
		this.iron = iron;
	}

	public Double getFiber() {
		return fiber;
	}

	public void setFiber(Double fiber) {
		this.fiber = fiber;
	}

	@Override
    public boolean equals(Object obj){
    	if (!(obj instanceof Ingredient)) return false;
    	Ingredient u = (Ingredient) obj;
    	return this.getId().equals(u.getId());
    }

}
