package uoc.com.mimenudehoy.model;

import java.io.Serializable;
import java.util.ArrayList;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;


@Entity
@Table(name = "menus")
public class Menu implements Serializable {

	private static final long serialVersionUID = -6120647971200252763L;
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	private String name;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "starter", nullable = false)  		
	private Dish starter;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "main", nullable = false)  		
	private Dish main;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "dessert", nullable = false)  		
	private Dish dessert;
	
	@Enumerated(EnumType.ORDINAL)
	private EnumMenuType type;
	
		
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Dish getStarter() {
		return starter;
	}

	public void setStarter(Dish starter) {
		this.starter = starter;
	}

	public Dish getMain() {
		return main;
	}

	public void setMain(Dish main) {
		this.main = main;
	}

	public Dish getDessert() {
		return dessert;
	}

	public void setDessert(Dish dessert) {
		this.dessert = dessert;
	}

	public EnumMenuType getType() {
		return type;
	}

	public void setType(EnumMenuType type) {
		this.type = type;
	}

	

}
