package uoc.com.mimenudehoy.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import org.springframework.security.core.GrantedAuthority;

@Entity
@Table(name="roles")
public class Role implements GrantedAuthority, Serializable {

	private static final long serialVersionUID = 7050429579853500245L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
    private Integer id;
     
    private String authority;
    
	@Override
    public boolean equals(Object obj){
    	if (!(obj instanceof Role)) return false;
    	Role u = (Role) obj;
    	return this.getId().equals(u.getId());
    }

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getAuthority() {
		return authority;
	}

	public void setAuthority(String authority) {
		this.authority = authority;
	}
	
	@Override
	public String toString(){
		return "id:"+this.getId() + " authority:" + this.getAuthority();
	}

	@Override
	public int hashCode(){
		return this.getId().hashCode();
	}
	
}