package uoc.com.mimenudehoy.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
@Table(name = "subscriptions")
public class Subscription implements Serializable {

	private static final long serialVersionUID = 8337682705275040952L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	
	@Column(nullable = false)
	@Temporal(TemporalType.DATE)
	private Date start_date;
	
	@Column(nullable = false)
	@Temporal(TemporalType.DATE)	
	private Date end_date;
	
	@Enumerated(EnumType.ORDINAL)
	private EnumMenuType menuType;
	
	private Double cost;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name="user")
	private User user;

	@OneToMany(fetch = FetchType.LAZY, cascade={CascadeType.ALL},mappedBy = "subscription")
	private List<MenuDaily> menus = new ArrayList<MenuDaily>();
	
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Date getStart_date() {
		return start_date;
	}

	public void setStart_date(Date start_date) {
		this.start_date = start_date;
	}

	public Date getEnd_date() {
		return end_date;
	}

	public void setEnd_date(Date end_date) {
		this.end_date = end_date;
	}

	public EnumMenuType getMenuType() {
		return menuType;
	}

	public void setMenuType(EnumMenuType menuType) {
		this.menuType = menuType;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public Double getCost() {
		return cost;
	}

	public void setCost(Double cost) {
		this.cost = cost;
	}

	@Override
	public boolean equals(Object x){
		if(!(x instanceof Subscription)) return false;
		Subscription y = (Subscription) x;
		return y.getId().equals(this.getId());
	}

	
	public List<MenuDaily> getMenus() {
		return menus;
	}

	public void setMenus(List<MenuDaily> menus) {
		this.menus = menus;
	}
	
	/*
	public static double getSubscriptionPrice(EnumMenuType tipo){
		if(tipo==EnumMenuType.STANDARD) return 9;
		else if (tipo==EnumMenuType.VEGETARIAN) return 10;
		else if (tipo==EnumMenuType.NO_GLUTEN) return 13;
		else if (tipo==EnumMenuType.NO_ALERGENS) return 15;
		else if (tipo==EnumMenuType.LOW_CALORIES) return 12;
		return 0;
	}
	*/

	
}
