package uoc.com.mimenudehoy.model;

import java.io.Serializable;
import java.util.Date;

import uoc.com.mimenudehoy.common.Utils;


public class SubscriptionAssign implements Serializable {

	private static final long serialVersionUID = -3664196843895194557L;
	
	private Long id;	
	private Date start_date;
	private Date end_date;

	private Integer days;
	
	private Integer numMenus;
	
	private EnumMenuType menuType;
	
	private Double cost;

	private User user;

	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Date getStart_date() {
		return start_date;
	}

	public void setStart_date(Date start_date) {
		this.start_date = start_date;
	}

	public Date getEnd_date() {
		return end_date;
	}

	public void setEnd_date(Date end_date) {
		this.end_date = end_date;
	}

	public EnumMenuType getMenuType() {
		return menuType;
	}

	public void setMenuType(EnumMenuType menuType) {
		this.menuType = menuType;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public Double getCost() {
		return cost;
	}

	public void setCost(Double cost) {
		this.cost = cost;
	}

	@Override
	public boolean equals(Object x){
		if(!(x instanceof SubscriptionAssign)) return false;
		SubscriptionAssign y = (SubscriptionAssign) x;
		return y.getId().equals(this.getId());
	}

	public Integer getDays() {
		return days;
	}

	public void setDays(Integer days) {
		this.days = days;
	}

	public Integer getNumMenus() {
		return numMenus;
	}

	public void setNumMenus(Integer numMenus) {
		this.numMenus = numMenus;
	}

	public SubscriptionAssign(Subscription subs){
		this.id = subs.getId();
		this.cost = subs.getCost();
		this.days = Utils.getDaysBetween(subs.getEnd_date(), subs.getStart_date());
		this.end_date = subs.getEnd_date();
		this.menuType = subs.getMenuType();
		this.numMenus = subs.getMenus().size();
		this.start_date = subs.getStart_date();
		this.user = subs.getUser();
	}
	
}
