package uoc.com.mimenudehoy.model.validator;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

import uoc.com.mimenudehoy.model.Ingredient;
import uoc.com.mimenudehoy.service.IngredientService;

@Component
public class IngredientValidator implements Validator {

	@Autowired
	private IngredientService ingService;

	public boolean supports(Class clazz) {
		return Ingredient.class.equals(clazz);
	}

	public void validate(Object target, Errors errors) {
		Ingredient user = (Ingredient) target;
		String name = user.getName();
		Long id = user.getId();
		
		if(name.isEmpty()) {
			errors.rejectValue("name", "error.required");
			return;
		}

		// do "complex" validation here
		List<Ingredient> tmp = ingService.getIngredients(name);
		for(Ingredient ing:tmp){
			if(ing.getId()!=id) {
				errors.rejectValue("name", "ingredient.error.name_exists");				
			}
		}
	}

}
