package uoc.com.mimenudehoy.service.impl;

import java.util.List;

import org.hibernate.Hibernate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.com.mimenudehoy.dao.DishDao;
import uoc.com.mimenudehoy.model.Dish;
import uoc.com.mimenudehoy.model.EnumCourseType;
import uoc.com.mimenudehoy.service.DishService;

@Service
public class DishServiceImpl implements DishService {

	@Autowired
	private DishDao dao;

	@Transactional
	public void save(Dish obj) {
		dao.save(obj);
	}

	@Transactional(readOnly = true)
	public List<Dish> listDishes() {
		return dao.list();
	}

	@Transactional(readOnly = true)
	public Dish getDishByName(String name) {
		return dao.findByName(name);
	}

	@Transactional
	public void delete(String id ) {
		dao.delete(id);
	}

	@Transactional(readOnly = true)
	public Dish getDish(String id) {
		Dish d = dao.findById(id);
		if(d!=null) Hibernate.initialize(d.getIngredients());
		return d;
	}

	@Transactional(readOnly = true)	
	public List<Dish> getDishesByType(EnumCourseType type) {
		return dao.findByType(type);
	}

}
