package uoc.com.mimenudehoy.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.com.mimenudehoy.dao.IngredientDao;
import uoc.com.mimenudehoy.model.Ingredient;
import uoc.com.mimenudehoy.service.IngredientService;

@Service
public class IngredientServiceImpl implements IngredientService {

	@Autowired
	private IngredientDao dao;

	@Transactional
	public void save(Ingredient user) {
		dao.save(user);
	}

	@Transactional(readOnly = true)
	public List<Ingredient> listIngredients() {
		return dao.list();
	}

	@Transactional(readOnly = true)
	public List<Ingredient> getIngredients(String username) {
		return dao.findByName(username);
	}

	@Transactional
	public void delete(String id ) {
		dao.delete(id);
	}

	@Transactional(readOnly = true)
	public Ingredient getIngredient(String id) {
		return dao.findById(id);
	}

}
