package uoc.com.mimenudehoy.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.com.mimenudehoy.dao.MenuDailyDao;
import uoc.com.mimenudehoy.dao.MenuDao;
import uoc.com.mimenudehoy.model.EnumMenuType;
import uoc.com.mimenudehoy.model.Menu;
import uoc.com.mimenudehoy.model.MenuDaily;
import uoc.com.mimenudehoy.service.MenuService;

@Service
public class MenuServiceImpl implements MenuService {

	@Autowired
	private MenuDao dao;

	@Autowired
	private MenuDailyDao mddao;
	
	
	@Transactional
	public void save(Menu user) {
		dao.save(user);
	}

	@Transactional(readOnly = true)
	public List<Menu> listMenus() {
		return dao.list();
	}

	@Transactional(readOnly = true)
	public List<Menu> getMenus(String username) {
		return dao.findByName(username);
	}

	@Transactional
	public void delete(String id ) {
		dao.delete(id);
	}

	@Transactional(readOnly = true)
	public Menu getMenu(String id) {
		return dao.findById(id);
	}

	@Transactional(readOnly = true)
	public List<Menu> listMenusByType(EnumMenuType type) {
		return dao.findByType(type);
	}

	@Transactional
	public void saveMenuDaily(MenuDaily m) {
		mddao.save(m);
	}
}
