package uoc.com.mimenudehoy.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.com.mimenudehoy.dao.RoleDao;
import uoc.com.mimenudehoy.dao.SubscriptionDao;
import uoc.com.mimenudehoy.dao.UserDao;
import uoc.com.mimenudehoy.model.EnumRoleAuthority;
import uoc.com.mimenudehoy.model.Role;
import uoc.com.mimenudehoy.model.Subscription;
import uoc.com.mimenudehoy.model.User;
import uoc.com.mimenudehoy.service.UserService;

@Service
public class UserServiceImpl implements UserService {

	@Autowired
	private UserDao userDao;

	@Autowired
	private RoleDao roleDao;

	@Autowired
	private SubscriptionDao subscriptionDao;

	
	@Transactional
	public void saveUser(User user) {

		//TODO: anyadir validacion no nulo
		for(Role role:user.getRoles()){
			System.out.println("role:"+ role.toString());
		}
		
		userDao.saveUser(user);
				
	}

	@Transactional(readOnly = true)
	public List<User> listUsers() {
		return userDao.listUsers();
	}

	@Transactional(readOnly = true)
	public User getUser(String username) {
		return userDao.findByUserName(username);
	}

	@Transactional
	public void deleteUser(String username) {
		userDao.deleteUser(username);
	}

	@Transactional(readOnly = true)
	public User getUser(Long id) {
		return userDao.getUser(id);
	}

	@Transactional(readOnly = true)
	public List<Role> listRoles() {
		return roleDao.list();
	}

	@Transactional(readOnly = true)
	public Role getRole(EnumRoleAuthority rol) {
		return roleDao.findByAuthority(rol.getValue());
	}

	@Transactional
	public void saveClient(User user) {
		Role roleClient = this.getRole(EnumRoleAuthority.CLIENT);
		user.getRoles().add(roleClient);
		userDao.saveUser(user);		
	}

	@Transactional(readOnly = true)
	public List<Subscription> getSubscriptions(User user) {
		return subscriptionDao.findActiveByUser(user);
	}

}
