<%@ include file="/WEB-INF/template/includes.jsp" %>
 
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
 
<!DOCTYPE html>
<html>
<head>
	<meta charset="UTF-8">
	<title><spring:message code="web.title"/></title>
	<link rel="stylesheet" type="text/css" href='<c:url value="/res/css/style.css"/>'>

	<script type='text/javascript' src="<c:url value="/res/js/lib/jquery-1.10.2.js"/>"></script>
	<link rel="stylesheet" href="<c:url value="/res/css/jquery-ui-1.10.4.custom.css" />">
	<script type='text/javascript' src="<c:url value="/res/js/lib/jquery-ui-1.10.4.custom.js"/>"></script>
	<script type='text/javascript' src="<c:url value="/res/js/lib/jquery.ui.datepicker-es.min.js"/>"></script>
	
	<script type='text/javascript' src="<c:url value="/res/js/common.js"/>"></script>
	
	<script type="text/javascript">
	var baseURL = '<c:out value="${pageContext.request.contextPath}"/>';
	</script>
	
</head>
<body>
	<div class="header">
		<div>
			<a href="index.html"><img src="<c:url value="/res/img/logo_v4.png"/>" alt="Logo"></a>
		</div>
		<form action="<c:url value="/searchRecipe"/>" method="post">
			<input type="text" name="text" placeholder="<spring:message code="web.searchText"/>" id="search">
			<input type="submit" value="" id="searchbtn">
		</form>
	</div>
	<div class="body">
	
		<div>
			<div class="header">
				<ul>
					<li <c:if test="${menu=='index' }">class="current"</c:if>>
						<a href="<c:url value="/index"/>">Inicio</a>
					</li>
					<li <c:if test="${menu=='recipes' }">class="current"</c:if> >
						<a href="<c:url value="/recipes"/>">Recetas</a>
					</li>
					<li <c:if test="${menu=='suscribe' }">class="current"</c:if> >
						<a href="<c:url value="/suscribe"/>">Suscripción</a>
					</li>
				<sec:authorize access="isAnonymous()">
					<li id="areaPrivada"><a href="<c:url value="/myMenus"/>"><spring:message code="menus.private"/></a></li>
				</sec:authorize>
				<sec:authorize ifAnyGranted="ROLE_CLIENT,ROLE_ADMIN,ROLE_NUTRI">
					<li <c:if test="${menu=='myMenus' }">class="current"</c:if>><a href="<c:url value="/myMenus"/>"><spring:message code="menus.myMenus"/></a></li>
					<li <c:if test="${menu=='myProfile' }">class="current"</c:if>><a href="<c:url value="/myProfile"/>"><spring:message code="menus.personal"/></a></li>
				</sec:authorize>					
				</ul>
			</div>
			<div class="body">
				
				<tiles:insertAttribute name="body" />
				
			</div>
			<div class="footer" >
				
				<tiles:insertAttribute name="footer" ignore="true"/>
				
			</div>
		</div>
		
		<div>
		

			<div>
				<h3><spring:message code="web.highlightRecipes" /></h3>
				
				<!-- destacados lateral -->
				<ul id="featured">
				<c:forEach items="${recipesLateral}" var="lat">
					<li>
						<c:url value="/recipe/${lat.id}" var="myurl"/>
						<a href="${myurl }">
							<c:if test="${empty lat.thumbBase64 }" >
								<img src="<c:url value="/res/img/defaultMenu.png"/>" alt="Image"></a>
							</c:if>
							<c:if test="${!empty lat.thumbBase64 }" >
								<img src="data:image/jpeg;base64,${lat.thumbBase64}" alt="${lat.thumbFileName }" width="60" height="60">
							</c:if>
						</a>
						<div>
							<h2><a href="${myurl }"><c:out value="${lat.name }"/></a></h2>
							<span><spring:message code="recipe.author"/>: <c:out value="${lat.author }"/></span>
						</div>
					</li>
					<%-- 
					<li>
						<a href="recipes.html"><img src="images/biscuit-and-coffee.jpg" alt="Image"></a>
						<div>
							<h2><a href="recipes.html">Biscuit &amp; Sandwich</a></h2>
							<span>by: Sarah</span>
						</div>
					</li>
					<li>
						<a href="recipes.html"><img src="images/pizza.jpg" alt="Image"></a>
						<div>
							<h2><a href="recipes.html">Delicious Pizza</a></h2>
							<span>by: Rico</span>
						</div>
					</li>
					--%>
					</c:forEach>
				</ul>
			</div>

		
			<div>
				<h3><spring:message code="web.follow"/></h3>
				<a href="http://mimenudehoy.com/go/facebook/" target="_blank" id="facebook">Facebook</a>
				<a href="http://mimenudehoy.com/go/twitter/" target="_blank" id="twitter">Twitter</a>
				<a href="http://mimenudehoy.com/go/youtube/" target="_blank" id="youtube">Youtube</a>
				<a href="http://mimenudehoy.com/go/flickr/" target="_blank" id="flickr">Flickr</a>
				<a href="http://mimenudehoy.com/go/googleplus/" target="_blank" id="googleplus">Google&#43;</a>
			</div>
		</div>
	</div>
	<div class="footer">
		<div>
			<p>
				&copy; Copyright 2016. All rights reserved
			</p>
		</div>
	</div>
</body>
</html>	